## python-escript 5.6

=== Makefile ===
# Minimal makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
SOURCEDIR     = sphinx_api
BUILDDIR      = doc

# Put it first so that "make" without argument is like "make help".
help:
	@$(SPHINXBUILD) -M help "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

.PHONY: help Makefile

# Catch-all target: route all unknown targets to Sphinx using the new
# "make mode" option.  $(O) is meant as a shortcut for $(SPHINXOPTS).
%: Makefile
	@$(SPHINXBUILD) -M $@ "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

=== SConstruct ===
##############################################################################
#
# Copyright (c) 2003-2018 by The University of Queensland
# http://www.uq.edu.au
#
# Primary Business: Queensland, Australia
# Licensed under the Apache License, version 2.0
# http://www.apache.org/licenses/LICENSE-2.0
#
# Development until 2012 by Earth Systems Science Computational Center (ESSCC)
# Development 2012-2013 by School of Earth Sciences
# Development from 2014 by Centre for Geoscience Computing (GeoComp)
#
##############################################################################

EnsureSConsVersion(0,98,1)
EnsurePythonVersion(2,5)

import atexit, sys, os, platform, re
from distutils import sysconfig
from dependencies import *
from site_init import *

print(sys.version)

# Version number to check for in options file. Increment when new features are
# added or existing options changed.
REQUIRED_OPTS_VERSION=203

# MS Windows support, many thanks to PH
IS_WINDOWS = (os.name == 'nt')

if IS_WINDOWS:
    IS_OSX = False
else:
    IS_OSX = (os.uname()[0] == 'Darwin')

########################## Determine options file ############################
# 1. command line
# 2. scons/<hostname>_options.py
# 3. name as part of a cluster
options_file=ARGUMENTS.get('options_file', None)
if not options_file:
    ext_dir = os.path.join(os.getcwd(), 'scons')
    hostname = platform.node().split('.')[0]
    for name in hostname, effectiveName(hostname):
        mangledhostname = re.sub('[^0-9a-zA-Z]', '_', hostname)
        options_file = os.path.join(ext_dir, mangledhostname+'_options.py')
        if os.path.isfile(options_file): break

if not os.path.isfile(options_file):
    print("\nWARNING:\nOptions file %s" % options_file)
    print("not found! Default options will be used which is most likely suboptimal.")
    print("We recommend that you copy the most relavent options file in the scons/template/")
    print("subdirectory and customize it to your needs.\n")
    options_file = None

############################### Build options ################################

default_prefix='/usr'
mpi_flavours=('no', 'none', 'MPT', 'MPICH', 'MPICH2', 'OPENMPI', 'INTELMPI')
netcdf_flavours = ('no', 'off', 'none', 'False', # Must be last of the false alternatives
                   'yes', 'on', 'True', '3', # Must be last of the version 3 alternatives
                   '4')
all_domains = ['dudley','finley','ripley','speckley']

#Note that scons construction vars the the following purposes:
#  CPPFLAGS -> to the preprocessor
#  CCFLAGS  -> flags for _both_ C and C++
#  CXXFLAGS -> flags for c++ _only_
#  CFLAGS   -> flags for c only

vars = Variables(options_file, ARGUMENTS)
vars.AddVariables(
  PathVariable('options_file', 'Path to options file', options_file, PathVariable.PathIsFile),
  PathVariable('prefix', 'Installation prefix', Dir('#.').abspath, PathVariable.PathIsDirCreate),
  PathVariable('build_dir', 'Top-level build directory', Dir('#/build').abspath, PathVariable.PathIsDirCreate),
  BoolVariable('verbose', 'Output full compile/link lines', False),
# Compiler/Linker options
  ('cxx', 'Path to C++ compiler', 'default'),
  ('cc_flags', 'Base (C and C++) compiler flags', 'default'),
  ('cc_optim', 'Additional (C and C++) flags for a non-debug build', 'default'),
  ('cc_debug', 'Additional (C and C++) flags for a debug build', 'default'),
  ('cxx_extra', 'Extra C++ compiler flags', ''),
  ('ld_extra', 'Extra linker flags', ''),
  BoolVariable('werror','Treat compiler warnings as errors', True),
  BoolVariable('debug', 'Compile with debug flags', False),
  BoolVariable('openmp', 'Compile parallel version using OpenMP', False),
  ('omp_flags', 'OpenMP compiler flags', 'default'),
  ('omp_ldflags', 'OpenMP linker flags', 'default'),
# Mandatory libraries
  ('boost_prefix', 'Prefix/Paths of boost installation', default_prefix),
  ('boost_libs', 'Boost libraries to link with', ['boost_python-mt']),
# Mandatory for tests
  ('cppunit_prefix', 'Prefix/Paths of CppUnit installation', default_prefix),
  ('cppunit_libs', 'CppUnit libraries to link with', ['cppunit']),
# Optional libraries and options
  EnumVariable('mpi', 'Compile parallel version using MPI flavour', 'none', allowed_values=mpi_flavours),
  ('mpi_prefix', 'Prefix/Paths of MPI installation', default_prefix),
  ('mpi_libs', 'MPI shared libraries to link with', ['mpi']),
  BoolVariable('use_gmsh', 'Enable gmsh, if available', True),
  EnumVariable('netcdf', 'Enable netCDF file support', False, allowed_values=netcdf_flavours),
  ('netcdf_prefix', 'Prefix/Paths of netCDF installation', default_prefix),
  ('netcdf_libs', 'netCDF libraries to link with', 'DEFAULT'),
  BoolVariable('parmetis', 'Enable ParMETIS (requires MPI)', False),
  ('parmetis_prefix', 'Prefix/Paths of ParMETIS installation', default_prefix),
  ('parmetis_libs', 'ParMETIS libraries to link with', ['parmetis', 'metis']),
  BoolVariable('mkl', 'Enable the Math Kernel Library', False),
  ('mkl_prefix', 'Prefix/Paths to MKL installation', default_prefix),
  ('mkl_libs', 'MKL libraries to link with', ['mkl_solver','mkl_em64t','guide','pthread']),
  BoolVariable('umfpack', 'Enable UMFPACK', False),
  ('umfpack_prefix', 'Prefix/Paths to UMFPACK installation', default_prefix),
  ('umfpack_libs', 'UMFPACK libraries to link with', ['umfpack']),
  BoolVariable('mumps', 'Enable MUMPS', False),
  ('mumps_prefix', 'Prefix/Paths to MUMPS installation', default_prefix),
  ('mumps_libs', 'MUMPS libraries to link with', ['mumps_common','pord','dmumps','zmumps',
    'mpiseq','lapack','metis','scotch','esmumps','gfortran']),
  TristateVariable('lapack', 'Enable LAPACK', 'auto'),
  ('lapack_prefix', 'Prefix/Paths to LAPACK installation', default_prefix),
  ('lapack_libs', 'LAPACK libraries to link with', []),
  BoolVariable('silo', 'Enable the Silo file format in weipa', False),
  ('silo_prefix', 'Prefix/Paths to Silo installation', default_prefix),
  ('silo_libs', 'Silo libraries to link with', ['siloh5', 'hdf5']),
  BoolVariable('trilinos', 'Enable the Trilinos solvers', False),
  ('trilinos_prefix', 'Prefix/Paths to Trilinos installation', default_prefix),
  ('trilinos_libs', 'Trilinos libraries to link with', []),
  BoolVariable('visit', 'Enable the VisIt simulation interface', False),
  ('visit_prefix', 'Prefix/Paths to VisIt installation', default_prefix),
  ('visit_libs', 'VisIt libraries to link with', ['simV2']),
  ListVariable('domains', 'Which domains to build', 'all', all_domains),
  BoolVariable('paso', 'Build Paso solver library', True),
  BoolVariable('weipa', 'Build Weipa data export library', True),
  ('mathjax_path', 'Path to MathJax.js file', 'default'),
# Advanced settings
  ('launcher', 'Launcher command (e.g. mpirun)', 'default'),
  ('prelaunch', 'Command to execute before launcher (e.g. mpdboot)', 'default'),
  ('postlaunch', 'Command to execute after launcher (e.g. mpdexit)', 'default'),
  #dudley_assemble_flags = -funroll-loops      to actually do something
  ('dudley_assemble_flags', 'compiler flags for some dudley optimisations', ''),
  # To enable passing function pointers through python
  BoolVariable('iknowwhatimdoing', 'Allow non-standard C', False),
  # An option for specifying the compiler tools
  ('tools_names', 'Compiler tools to use', ['default']),
  ('env_export', 'Environment variables to be passed to tools',[]),
  TristateVariable('forcelazy', 'For testing use only - set the default value for autolazy', 'auto'),
  TristateVariable('forcecollres', 'For testing use only - set the default value for force resolving collective ops', 'auto'),
  BoolVariable('build_shared', '(deprecated option, ignored)', True),
  ('sys_libs', 'Extra libraries to link with', []),
  ('escript_opts_version', 'Version of options file (do not specify on command line)'),
  ('SVN_VERSION', 'Do not use from options file', -2),
  ('pythoncmd', 'which python to compile with', sys.executable),
  ('pythonlibname', 'Name of the python library to link. (This is found automatically for python2.X.)', ''),
  ('pythonlibpath', 'Path to the python library. (You should not need to set this unless your python has moved)',''),
  ('pythonincpath','Path to python include files. (You should not need to set this unless your python has moved',''),
  BoolVariable('longindices', 'use long indices (for very large matrices)', False),
  BoolVariable('compressed_files','Enables reading from compressed binary files', True),
  ('compression_libs', 'Compression libraries to link with', ['boost_iostreams']),
  BoolVariable('disable_boost_numpy', 'Do not build using boost_numpy, even if it is available', False),
  BoolVariable('osx_dependency_fix', 'Fix dependencies for libraries to have absolute paths (OSX)', False),
  BoolVariable('stdlocationisprefix', 'Set the prefix as escript root in the launcher', False),
  BoolVariable('mpi_no_host', 'Do not specify --host in run-escript launcher (only OPENMPI)', False),
  BoolVariable('insane', 'Instructs scons to not run a sanity check after compilation.', False)
)

##################### Create environment and help text #######################

# Intel's compiler uses regular expressions improperly and emits a warning
# about failing to find the compilers. This warning can be safely ignored.

# PATH is needed so the compiler, linker and tools are found if they are not
# in default locations.
env = Environment(tools = ['default'], options = vars,
                  ENV = {'PATH': os.environ['PATH']})

# set the vars for clang
def mkclang(env):
    env['CXX']='clang++'

if env['tools_names'] != ['default']:
    zz=env['tools_names']
    if 'clang' in zz:
        zz.remove('clang')
        zz.insert(0, mkclang)
    env = Environment(tools = ['default'] + env['tools_names'], options = vars,
                      ENV = {'PATH' : os.environ['PATH']})

# Covert env['netcdf'] into one of False, 3, 4
# Also choose default values for libraries
pos1=netcdf_flavours.index('False')
pos2=netcdf_flavours.index('3')
mypos=netcdf_flavours.index(env['netcdf'])
if 0 <= mypos <=pos1:
    env['netcdf']=0
elif pos1 < mypos <= pos2:
    env['netcdf']=3
    if env['netcdf_libs']=='DEFAULT':
        env['netcdf_libs']=['netcdf_c++', 'netcdf']
else:   # netcdf4
    env['netcdf']=4
    if env['netcdf_libs']=='DEFAULT':
        env['netcdf_libs']=['netcdf_c++4']

if options_file:
    opts_valid=False
    if 'escript_opts_version' in env.Dictionary() and \
        int(env['escript_opts_version']) >= REQUIRED_OPTS_VERSION:
            opts_valid=True
    if opts_valid:
        print("Using options in %s." % options_file)
    else:
        print("\nOptions file %s" % options_file)
        print("is outdated! Please update the file after reading scons/templates/README_FIRST")
        print("and setting escript_opts_version to %d.\n"%REQUIRED_OPTS_VERSION)
        Exit(1)

# Generate help text (scons -h)
Help(vars.GenerateHelpText(env))

# Check for superfluous options
if len(vars.UnknownVariables())>0:
    for k in vars.UnknownVariables():
        print("Unknown option '%s'" % k)
    Exit(1)

if 'dudley' in env['domains']:
    env['domains'].append('finley')

env['domains'] = sorted(set(env['domains']))

# create dictionary which will be populated with info for buildvars file
env['buildvars'] = {}
# create list which will be populated with warnings if there are any
env['warnings'] = []

#################### Make sure install directories exist #####################

env['BUILD_DIR'] = Dir(env['build_dir']).abspath
prefix = Dir(env['prefix']).abspath
env['buildvars']['prefix'] = prefix
env['incinstall'] = os.path.join(prefix, 'include')
env['bininstall'] = os.path.join(prefix, 'bin')
if IS_WINDOWS:
    env['libinstall'] = env['bininstall']
else:
    env['libinstall'] = os.path.join(prefix, 'lib')
env['pyinstall']  = os.path.join(prefix, 'esys')
if not os.path.isdir(env['bininstall']):
    os.makedirs(env['bininstall'])
if not os.path.isdir(env['libinstall']):
    os.makedirs(env['libinstall'])

=== cusplibrary/testing/SConstruct ===
import os
import inspect

# try to import an environment first
try:
  Import('env')
except:
  exec open("../build/build-env.py")
  env = Environment()

# on mac we have to tell the linker to link against the C++ library
if env['PLATFORM'] == "darwin":
  env.Append(LINKFLAGS = "-lstdc++")

# on windows we have to do /bigobj
if env['PLATFORM'] == "win32" or env['PLATFORM'] == "win64":
  env.Append(CPPFLAGS = "/bigobj")

# find all .cus & .cpps in the current and backend/ directories
sources = []
directories = ['.', 'backend']
extensions = ['*.cu', '*.cpp']

# finall all backend-specific files
if env['backend'] == 'cuda' or env['backend'] == 'ocelot':
  directories.append(os.path.join('backend','cuda'))
elif env['backend'] == 'omp':
  directories.append(os.path.join('backend','omp'))

for dir in directories:
  for ext in extensions:
    regexp = os.path.join(dir, ext)
    sources.extend(env.Glob(regexp))

# filter test files using a regular expression
if 'tests' in env:
  import re

  pattern = re.compile(env['tests'])

  necessary_sources = set(['testframework.cu'])
  filtered_sources  = []

  for f in sources:
    if str(f) in necessary_sources or pattern.search(f.get_contents()):
      filtered_sources.append(f)

  sources = filtered_sources

# add the directory containing this file to the include path
this_file = inspect.currentframe().f_code.co_filename
this_dir = os.path.dirname(this_file)
env.Append(CPPPATH = [this_dir])

tester = env.Program('tester', sources)

=== cusplibrary/examples/OpenGL/SConstruct ===
import os
import inspect
import glob

# try to import an environment first
try:
  Import('env')
except:
  exec open("../../build/build-env.py")
  env = Environment()

# on mac we have to tell the linker to link against the C++ library
if env['PLATFORM'] == "darwin":
  env.Append(LINKFLAGS = ["-framework","GLUT", "-framework","OpenGL", "-framework","glew"])
else :
  env.Append(LIBS = ["glut","GL","GLU"])

# find all .cus & .cpps in the current directory
sources = []
extensions = ['*.cu', '*.cpp']
for ext in extensions:
  sources.extend(glob.glob(ext))

# compile examples
for src in sources:
  env.Program(src)

=== cusplibrary/testing/trivial_tests/SConstruct ===
import os
import glob
from warnings import warn

cusp_abspath = os.path.abspath("../../cusp/")

# try to import an environment first
try:
  Import('env')
except:
  exec open("../../build/build-env.py")
  env = Environment()

# this function builds a trivial source file from a Cusp header
def trivial_source_from_header(source, target, env):
  src_abspath = str(source[0])
  src_relpath = os.path.relpath(src_abspath, cusp_abspath)
  include = os.path.join('cusp', src_relpath)

  target_filename = str(target[0])
  fid = open(target_filename, 'w')
  fid.write('#include <' + include + '>\n')
  fid.close()


# CUFile builds a trivial .cu file from a Cusp header
cu_from_header_builder = Builder(action = trivial_source_from_header,
                                 suffix = '.cu',
                                 src_suffix = '.h')
env.Append(BUILDERS = {'CUFile' : cu_from_header_builder})

# CPPFile builds a trivial .cpp file from a Cusp header
cpp_from_header_builder = Builder(action = trivial_source_from_header,
                                  suffix = '.cpp',
                                  src_suffix = '.h')
env.Append(BUILDERS = {'CPPFile' : cpp_from_header_builder})


# find all user-includable .h files in the cusp tree and generate trivial source files #including them
extensions = ['.h']
folders = ['',              # main folder
           'gallery/',
           'graph/',
           'io/',
           'krylov/',
           'precond/',
           'relaxation/']

sources  = []

for folder in folders:
  for ext in extensions:
    pattern = os.path.join(os.path.join(cusp_abspath, folder), "*" + ext)
    for fullpath in glob.glob(pattern):
      headerfilename = os.path.basename(fullpath)

      cu  = env.CUFile(headerfilename.replace('.h', '.cu'), fullpath)
      cpp = env.CPPFile(headerfilename.replace('.h', '_cpp.cpp'), fullpath)

      sources.append(cu)
      #sources.append(cpp)  # TODO: re-enable this

      # insure that all files #include <cusp/detail/config.h>
      fid = open(fullpath)
      if '#include <cusp/detail/config.h>' not in fid.read():
        warn('Header <cusp/' + folder + headerfilename + '> does not include <cusp/detail/config.h>')

# and the file with main()
sources.append('main.cu')
tester = env.Program('tester', sources)

=== debian/changelog ===
python-escript (5.6-10) unstable; urgency=medium

  * Team upload.
  * Use T1 encoding to fix LaTeX errors. Closes: #1088894.
  * Fix build on i386 and mip64el. Closes: #1041457.
    Thanks to Adrian Bunk.
  * debian/rules: Fix several typos.
  * debian/control: Filter with "expand", so that at least we can
    get rid of tabs, and drop trailing spaces.
  * debian/control: Drop unused libnetcdf-dev build dependency.
    Closes: #1050794. Thanks to Bas Couwenberg.
  * debian/control: Add missing build-dependency on python3-setuptools.
    Closes: #1080744. Thanks to Stefano Rivera.
  * Fix changelog entries for 5.6-6 and 5.6-8.

 -- Santiago Vila <sanvila@debian.org>  Fri, 13 Dec 2024 13:10:00 +0100

python-escript (5.6-9) unstable; urgency=medium

  * Change dep from openmpi-bin to mpi-default-bin in d/control.
    Closes: #1086918, #1088137

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 24 Nov 2024 16:05:24 +0000

python-escript (5.6-8) unstable; urgency=medium

  * py3.13.patch: Allow escapes in string
  * Standards-Version: 4.7.0; no changes required
  * Escript moved to github.io; update d/control
  * Add d/watch (needs additional work)
  * Move openmpi -> mpi-default. Closes: #1086918
  * Don't link against mpi_cxx. Closes: #1086371
  * Change multiarch patch to work with both mpich and openmpi

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 21 Nov 2024 13:42:01 +0000

python-escript (5.6-7) unstable; urgency=medium

  * Team upload.
  * debian/control: Apply "wrap-and-sort -abst" and unify between tabs
    and spaces.
  * debian/control: Move the main package descriptions to the source package
    section. Use variable replacement ${source:Synopsis} and
    ${source:Extended-Description} to avoid repeated boilerplate.
  * debian/control: Fix Vcs-* field syntax.
  * debian/gbp.conf: Use status quo and update default debian-branch to
    "debian/latest". Also add ignore-branch = True to circumvent pedantic
    issues.

  [ Bo YU ]
  * Team upload.
  * Add fix-dpkg-buildflags-on-c-c++.patch to fix ftbfs issue.
    (Closes: #1068158)
  * No build dependencies issue now. (Closes: #1067385)

 -- Boyuan Yang <byang@debian.org>  Wed, 03 Apr 2024 10:52:48 -0400

python-escript (5.6-6) unstable; urgency=medium

  * Update patch for new buildflags. Closes: #1057593

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 10 Dec 2023 10:53:54 +0000

python-escript (5.6-5) unstable; urgency=medium

  * Standards-Version: 4.6.2
  * Drop build-dep on netcdf-legacy-cxx. Closes: #1038468

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 03 Aug 2023 11:13:07 +0100

python-escript (5.6-4) unstable; urgency=medium

  * Standards-Version: 4.6.0
  * 'which' no longer present ; change sh scripts to use command -v
    or search path in python
  * Ignore new ASFLAGS in dpkg-buildpackage output. Closes: #10002428
  * Build against latest numpy, sphinx, Closes: #999530

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 01 Jan 2022 11:40:25 +0000

python-escript (5.6-3) unstable; urgency=medium

  * Fix FTBFS with new DFLAG in dpkg-buildflags. Closes: #986516

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 07 Apr 2021 17:17:31 +0100

python-escript (5.6-2) unstable; urgency=medium

  * Ack bugs fixed: Closes: #976555, #976687
  * Fix boost_numpy.patch to find lib properly

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 10 Dec 2020 17:53:59 +0000

python-escript (5.6-1) unstable; urgency=medium

  * New upstream release
  * Drop python3-sympy until escript supports sympy >  1.2. Closes: #876555
  * Fix bug in sid_options.py that results in linking to the wrong
    boost_python library. Closes: #97687
  * Patch g++-10.patch to fix compilation on g++-10
  * Patch tex.patch to fix errors that break on pdflatex
  * Drop python3-gdal; escript exports gdal module, not osgeo. Needs updating
  * Build-depend and support:
    - libcppunit-dev for cppunit
    - libsuitesparse-dev for umfpack
    - libboost-numpy-dev for Numpy Boost support
    - libboost-iostream-dev for compressed files support
    - Drop trilinos build-deps; currently not working
    - B-D on libscotchmetis-dev and libscotchparmetis-dev for parmetis support
  * Debhelper level 13
  * Standards-Version: 4.5.1
  * No longer ignore dwz errors; fixed
  * Patch boost_numpy.patch to find correct lib

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 09 Dec 2020 16:57:30 +0000

=== debian/control ===
Source: python-escript
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders:
 Joel Fenwick <j.oelpublic@gmail.com>,
 Alastair McKinstry <mckinstry@debian.org>,
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-sequence-python3,
               dh-sequence-sphinxdoc,
               python3-setuptools,
               python3-dev,
               python3-gdal,
               python3-matplotlib,
               python3-numpy,
               python3-scipy,
               python3-pyproj,
               libcppunit-dev,
               libsuitesparse-dev,
               libboost-python-dev,
               libboost-random-dev,
               libboost-numpy-dev,
               libboost-iostreams-dev,
               libnetcdf-c++4-dev,
               libsilo-dev (>= 4.10.2.real-5),
               libscotchparmetis-dev,
               libscotchmetis-dev,
               gmsh,
               mpi-default-dev,
               mpi-default-bin,
               scons,
               zip,
               python3-sphinx,
               doxygen,
               texlive,
               ghostscript,
               texlive-latex-extra,
               texlive-latex-recommended,
               lsb-release,
               libjs-mathjax
Standards-Version: 4.7.0
Homepage: https://github.com/esys-escript/esys-escript.github.io
Vcs-Browser: https://salsa.debian.org/science-team/python-escript
Vcs-Git: https://salsa.debian.org/science-team/python-escript.git
Description: Escript/Finley finite elements Python3 system
 Escript is a programming tool for implementing mathematical models in Python
 using the finite element method (FEM). Because users do not access the data
 structures it is very easy to use and scripts can run on desktop computers as
 well as highly parallel supercomputer without changes. Application areas for
 escript include earth mantle convection, geophysical inversion, earthquakes,
 porous media flow, reactive transport, plate subduction, erosion, and
 tsunamis.
 .
 Scripts can be executed in parallel (on varying numbers of threads or nodes)
 without any special modifications.
 .
 Escript now includes the esys.downunder module for 3D inversion of geophysical
 data sets. The current version supports gravity, magnetic and joint inversion.

Package: python3-escript
Architecture: any
Section: python
Depends: ${python3:Depends},
         python3-numpy,
         mpi-default-bin,
         ${shlibs:Depends},
         ${misc:Depends}
Recommends: python3-sympy,
            python3-matplotlib,
            python3-scipy
Suggests: python3-pyproj,
          python3-gdal,
          python-escript-doc
Description: Escript/Finley finite elements Python3 system (OpenMP + MPI)
 Escript is a programming tool for implementing mathematical models in Python
 using the finite element method (FEM). Because users do not access the data
 structures it is very easy to use and scripts can run on desktop computers as
 well as highly parallel supercomputer without changes. Application areas for
 escript include earth mantle convection, geophysical inversion, earthquakes,
 porous media flow, reactive transport, plate subduction, erosion, and
 tsunamis.
 .
 This package contains the commands and libraries for Python3 with
 OpenMP threading and MPI multiprocess support.

Package: python-escript-doc
Architecture: all
Section: doc
Depends:
 doc-base,
 libjs-mathjax,
 libjs-sphinxdoc,
 sphinx-common,
 ${misc:Depends},
 ${sphinxdoc:Depends},
Recommends:
 python3-escript,
Description: Documentation for Escript/Finley
 ${source:Extended-Description}
 .
 This package contains the documentation for escript,
 including example scripts the user guide, the cookbook (an introduction from
 a geoscientists point of view) and a guide to the esys.downunder inversion
 toolkit.

Package: python3-escript-mpi
Architecture: any
Section: python
Depends:
 mpi-default-bin,
 python3-numpy,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Recommends:
 python3-matplotlib,
 python3-scipy,
 python3-sympy,
Suggests:
 python-escript-doc,
 python3-gdal,
 python3-pyproj,
Description: ${source:Description} (OpenMP + MPI)
 ${source:Extended-Description}
 .
 This package contains the commands and libraries for Python3 with
 both OpenMP threading and MPI multiprocess support.

=== debian/rules ===
#!/usr/bin/make -f

PROJROOT=$(CURDIR)
B3DEST=$(CURDIR)/debian/python3-escript
B3MDEST=$(CURDIR)/debian/python3-escript-mpi
DDEST=$(CURDIR)/debian/python-escript-doc
BUILD3=$(CURDIR)/debian/tmp3
BUILD3M=$(CURDIR)/debian/tmp3M
WORK3=$(CURDIR)/debian/stage3
WORK3M=$(CURDIR)/debian/stage3M

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# The additional -Werror=implicit-function-declaration is useless in its functionality,
# but it is useful to satisfy a pedantic buildflag check in the source code.
# See https://bugs.debian.org/1068158 and debian/patches/fix-dpkg-buildflags-on-c-c++.patch
export DEB_CXXFLAGS_MAINT_APPEND = -Wno-uninitialized -Werror=implicit-function-declaration
export DEB_CFLAGS_MAINT_APPEND = -Wno-uninitialized

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk


#thanks to the debian manual
# export DEB_BUILD_OPTIONS="parallel=10"
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    PARBUILD:=$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    SFLAGS:=-j$(PARBUILD)
else
    SFLAGS:=-j1
endif

ifeq ($(DEB_HOST_ARCH_BITS), 64)
  OPT := -O3
else
  OPT := -Os -g1
endif

ifeq ($(DEB_HOST_ARCH), mips64el)
  OPT += -mxgot
endif

%:
	dh $@  -v

override_dh_clean:
	find . -name '*.pyc' -delete 
	rm -f itest.sh utest.sh
	rm -rf build condif.log esys include lib release .sconf_tmp .sconsign.dblite config.log .sconf_temp
	rm -rf $(B3DEST)
	rm -rf $(B3MDEST)
	rm -rf $(DDEST)
	rm -rf $(BUILD3)
	rm -rf $(BUILD3M)
	rm -rf $(WORK3)
	rm -rf $(WORK3M)
	rm -rf $(CURDIR)/debian/tmp/*
	rm -f debian/files
	rm -f debian/substvars
	dh_clean

override_dh_auto_clean:
	dh_clean

override_dh_installchangelogs:
	dh_installchangelogs debian/changelog.trivial

override_dh_auto_build:
	# Build steps for py3
	mkdir -p $(WORK3)
	(scons $(SFLAGS) cc_optim='$(OPT)'  build_dir=$(BUILD3) verbose=on prefix=$(WORK3) options_file=debian/sid_options.py docs ) || true
	# extract the relevant .py files
	cd $(WORK3); $(PROJROOT)/debian/utils/cppy.py $(PROJROOT); cd $(PROJROOT)
	cp $(PROJROOT)/doc/manpage/man1/run-escript.1 $(WORK3)/run-escript3.man
	ln $(WORK3)/bin/run-escript $(WORK3)/bin/run-escript3
	find $(WORK3) -name '*.pyc' -print0| xargs -0 rm -f

	mkdir -p $(BUILD3)
	# scons $(SFLAGS) build_dir=$(BUILD3) verbose=on prefix=$(WORK3) options_file=debian/sid_options.py docs
	find $(WORK3) -name '*.pyc' -print0 | xargs -0 rm -f

	# Build steps for py3 with MPI
	mkdir -p $(WORK3M)
	scons $(SFLAGS)  build_dir=$(BUILD3M)  cc_optim='$(OPT) -DOVERLORDPATH=\"/usr/lib/python-escript3-mpi/\"' \
		verbose=on prefix=$(WORK3M) options_file=debian/sid_options_mpi.py
	# extract the relevant .py files
	cd $(WORK3M); $(PROJROOT)/debian/utils/cppy.py $(PROJROOT); cd $(PROJROOT)
	cp $(PROJROOT)/doc/manpage/man1/run-escript.1 $(WORK3M)/run-escript3-mpi.man
	ln $(WORK3M)/bin/run-escript $(WORK3M)/bin/run-escript3-mpi
	find $(WORK3M) -name '*.pyc' -print0| xargs -0 rm -f	
	#rm -rf $(BUILD3M)	
	# fix paths in each package and
	# fix some external links in the doc package
	debian/utils/tweak.sh  "$(WORK3)" "$(WORK3M)"
	rm -f scons/templates/*.pyc
	rm -f site_scons/*.pyc
	rm -f utest.sh

override_dh_shlibdeps:
	# so libraries we just built are checked as well
	dh_shlibdeps -ppython3-escript  -Npython3-escript-mpi -Npython-escript-doc -P$(B3DEST) -l$(B3DEST)/usr/lib/python3-escript/lib
	dh_shlibdeps -ppython3-escript-mpi -Npython3-escript -Npython-escript-doc -P$(B3MDEST) -l$(B3MDEST)/usr/lib/python3-escript-mpi/lib

override_dh_python3:
	dh_python3 -ppython3-escript -Npython3-escript-mpi -Npython-escript-doc --no-ext-rename	usr/lib/python3-escript/esys
	dh_python3 -ppython3-escript-mpi -Npython3-escript -Npython-escript-doc --no-ext-rename	usr/lib/python3-escript-mpi/esys

=== debian/watch ===
version=4
opts="uversionmangle=s/-rc/~rc/, filenamemangle=s/.+\/(\d\S+)\.tar\.gz/$1\.tar\.gz/" \
  https://github.com//LutzGross/esys-escript.github.io/tags .*/?(\d\d?\d?).tar\.gz
